<template>
  <v-container>
    <filters :filters="filters" @emitFilters="getFilteredList" />
    <v-row>
      <v-col>
        <schedule-list :events="events" v-if="events" />
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import ScheduleList from '../components/ScheduleList'
import filters from '@c/Filters'
import Api from '@/mixins/api'

// @group VIEWS
export default {
  mixins: [Api],
  data() {
    return {
      filters: [
        { label: 'Tytuł', value: undefined, name: 'title' },
        { label: 'Opis', value: undefined, name: 'description' },
        { label: 'Organizatorzy', value: undefined, name: 'organizers' },
        { label: 'Miejsce', value: undefined, name: 'place' },
      ],
      filteredList: false,
    }
  },
  methods: {
    goToDetails(id) {
      this.$router.push(`/harmonogram/${id}`)
    },
    /**
     * @vuese
     * Get filtered list based on criteria
     * @arg Filters object
     */
    getFilteredList(filters) {
      this.filteredList = this.$store.state.events.filter(event => {
        return Object.keys(filters).reduce((acc, key) => {
          if (acc) {
            if (event[key] instanceof Date) {
              return event[key].toISOString().includes(filters[key])
            } else {
              return event[key].toLowerCase().includes(filters[key].toLowerCase())
            }
          }
        }, true)
      })
    },
  },
  computed: {
    /**
     * @vuese
     * Returns events from VueX store if list is not filtered
     * @arg -
     */
    events() {
      if (this.filteredList) {
        return this.filteredList
      } else {
        return this.$store.state.events
      }
    },
  },
  created() {
    /**
     * @vuese
     * Gets events every 60 seconds
     * @arg -
     */
    this.getEvents()
    setInterval(this.getEvents, 60000)
  },
  components: {
    filters,
    ScheduleList,
  },
}
</script>
